{-# OPTIONS -fth -fglasgow-exts #-}

module GenericHaskell.Datatypes where

import Common.EP

import GenericHaskell.GH

data GRose f a	= GFork a (f (GRose f a))
data Rose a	= Fork a [Rose a]	    deriving Show

instance Show a => Show (GRose [] a) where
    showsPrec _ (GFork x xs) = showString "GFork " . showsPrec 10 x . showString " " . showsPrec 10 xs

listD	= datatype' "* -> *"		    (reifyDecl [])
roseD	= datatype' "* -> *"		    (reifyDecl Rose)
groseD	= datatype' "(* -> *) -> * -> *"    (reifyDecl GRose)
pairD	= datatype' "* -> * -> *"	    (reifyDecl (,))
epD	= datatype' "* -> * -> *"	    (reifyDecl EP)

